/*************************************************************************************
*  Copyright (c) 1997-1998 by Joseph Parrello. All Rights Reserved.                  *
*  Site   : http://space.tin.it/computer/giparrel                                    *
*  E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it                         *
*                                                                                    *
*  Revision:   1.2a  (April 3, 1998).                                                *
*                                                                                    *
*  Definition of JPFlatButtonGadget class.                                           *
*                                                                                    *
*  Read JPFLTBTG.TXT for use and license.                                            *
*                                                                                    *
*  Only for OWL 5.02 and 5.01 users.                                                 *
*  OWL and ObjectWindows are trademarks of Borland International.                    *
*                                                                                    *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF                *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO               *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A                    *
*  PARTICULAR PURPOSE.                                                               *
*************************************************************************************/
#if !defined(jpfltbtg_h)              // Sentry, use file only if it's not already included.
#define jpfltbtg_h

#if !defined(OWL_BUTTONGA_H)
#include <owl/buttonga.h>
#endif


//{{TButtonGadget = JPFlatButtonGadget}}
class JPFlatButtonGadget : public TButtonGadget {
  public:
    JPFlatButtonGadget(TResId glyphResIdOrIndex, int id, TType type = Command, bool enabled = false, TState state = Up, bool sharedGlyph = false);
    virtual ~JPFlatButtonGadget();

//{{JPFlatButtonGadgetVIRTUAL_BEGIN}}
  protected:
    enum FlatState {
    	fsNormal,
      fsUp,
      fsDown,
    };
    FlatState     CurrentFlatState;
    bool          isEnter;
	 void 			SetFlatState(FlatState state, bool update=true);
    FlatState     GetFlatState() const;

  public:
    virtual void PaintBorder(TDC& dc);
    virtual void MouseEnter(uint modKeys, TPoint& point);
    virtual void MouseLeave(uint modKeys, TPoint& point);
    virtual void BeginPressed(TPoint& p);
    virtual void CancelPressed(TPoint& p);
    virtual void SetButtonState(TState newState);
    virtual bool IdleAction(long idleCount);
//{{JPFlatButtonGadgetVIRTUAL_END}}
};    //{{JPFlatButtonGadget}}

#endif  // jpfltbtg_h sentry.

